//+------------------------------------------------------------------+
//|                                                           dP.mq4 |
//| Copyright  2008: komposter -  ,   - kurtman |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2008, MQL Service"
#property link      "http://www.mqlservice.net"
#property show_inputs

#include <WinUser32.mqh>
#import "user32.dll"
   int RegisterWindowMessageA(string a0);
#import
//     ,   (",")
extern int  minPoint    = 50;        //     
extern int     name_minute = 2;
extern int		RefreshLuft	= 1000;
extern string	ChartList	= "EURUSD";

int Charts = 0, curChart = 0;
int HistoryHandle[];
double _close, _open, _low, _high, _volume;
int _time;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init() {
   if (ChartList=="") ChartList=StringConcatenate(Symbol(),Period());
   start();
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
     string prefix="";
     string postfix="";
	  int		_GetLastError = 0, temp[13], _Digits[], i=0, j=0;
	  int		pos = 0, curchar = 0, len= StringLen(ChartList);
	  string	cur_symbol = "", cur_period = "", file_name = "";
	  string	_Symbol[100];
	  int _Period[100], _Bars[];
	  int		hwnd[], last_fpos[], nb[], Time_nb[];
	  double	vol, _Point[];
	  bool NewBar=false;
	  int sec=60;
//--------------------------------------------------------	  
//----   ,   
	  while(pos <= len)
	    {
		  curchar = StringGetChar( ChartList, pos);
		  if(curchar > 47 && curchar < 58) cur_period = cur_period + CharToStr( curchar );
		    else
		     {
			   if(curchar == ',' || pos == len)
			     { 
				   MarketInfo(cur_symbol, MODE_BID);
				   if(GetLastError() == 4106)
				    {
					  Alert("  ", cur_symbol, "!!!");
					  return(-1);				
				    }
				   if(iClose(cur_symbol, StrToInteger( cur_period ), 0) <= 0)
				    {
				 	  Alert( "  ", cur_period, "!!!" );
					  return(-1);				
				    }
				   _Symbol[Charts] = cur_symbol; _Period[Charts] = StrToInteger(cur_period);
				   cur_symbol = ""; cur_period = "";
				   Charts ++;
			     }
			    else cur_symbol = cur_symbol + CharToStr(curchar); 
		      }
		  pos++;
	    }
	  Print("<---  ", Charts, "  . --->");
	  ArrayResize(_Symbol,	Charts); 
	  ArrayResize(_Period,	Charts);
	  ArrayResize(HistoryHandle, Charts);
	  ArrayInitialize(HistoryHandle,-1);
	  ArrayResize( hwnd,	Charts);
	  ArrayInitialize(hwnd,0);
	  ArrayResize(last_fpos, Charts); 
	  ArrayResize(_Bars,	Charts);
	  ArrayResize(nb,	Charts);
	  ArrayResize(Time_nb, Charts);
	  ArrayResize(_Point, Charts);
	  ArrayResize(_Digits, Charts);
     int tmf=StrToInteger(StringConcatenate(minPoint,name_minute));

	  for(curChart = 0; curChart < Charts; curChart++)
	    {
		     //----  ,     
		     _Digits[curChart]=MarketInfo(_Symbol[curChart],MODE_DIGITS);
		       file_name = StringConcatenate(_Symbol[curChart], tmf ,".hst");
		       HistoryHandle[curChart] = FileOpenHistory(file_name, FILE_BIN | FILE_WRITE);
		       if(HistoryHandle[curChart] < 0)
		        {
			      _GetLastError = GetLastError();
			      Alert("FileOpenHistory( \"", file_name, "\", FILE_BIN | FILE_WRITE )"," - Error #", _GetLastError);
			      continue;
		        }
		     //----   
		       FileWriteInteger(HistoryHandle[curChart], 400, LONG_VALUE); 
		       FileWriteString(HistoryHandle[curChart], "< Copyright  2006, mankurt >", 64);
		       FileWriteString(HistoryHandle[curChart], _Symbol[curChart], 12);
		       FileWriteInteger(HistoryHandle[curChart], tmf, LONG_VALUE);
		       FileWriteInteger(HistoryHandle[curChart], _Digits[curChart], LONG_VALUE);
		       FileWriteInteger(HistoryHandle[curChart], 0, LONG_VALUE);       //timesign
		       FileWriteInteger(HistoryHandle[curChart], 0, LONG_VALUE);       //last_sync
		       FileWriteArray	(HistoryHandle[curChart], temp, 0, 13);
		     //+------------------------------------------------------------------+
		     //|                                               |
		     //+------------------------------------------------------------------+
		     _Bars[curChart] = iBars(_Symbol[curChart], _Period[curChart]);
           _Point[curChart]=MarketInfo(_Symbol[curChart],MODE_POINT);
           
           nb[curChart]=_Bars[curChart]-2;
		     vol=0.0;
		     i = nb[curChart];
		     while( i >= 1)
		      {
		        vol+=iVolume(_Symbol[curChart], _Period[curChart], i);
		        //----   
		        if(TimeDayOfWeek(iTime(_Symbol[curChart],_Period[curChart],i+1))> 
                 TimeDayOfWeek(iTime(_Symbol[curChart],_Period[curChart],i)))
                {
                 if (nb[curChart]>i)
                 {
			         //----   
			         _open = iOpen(_Symbol[curChart], _Period[curChart], nb[curChart]);
			         _high = iHigh(_Symbol[curChart], _Period[curChart], iHighest(_Symbol[curChart], _Period[curChart],MODE_HIGH,nb[curChart]-i,i+1));
			         _low = iLow(_Symbol[curChart], _Period[curChart], iLowest(_Symbol[curChart], _Period[curChart],MODE_LOW,nb[curChart]-i,i+1));
			         _close = iClose(_Symbol[curChart], _Period[curChart], i+1);
			         _volume = vol-iVolume(_Symbol[curChart], _Period[curChart], i);
			         _time = iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
			         _time *= sec;
			         //----     
			         HistoryFileWrite();
			         vol=iVolume(_Symbol[curChart], _Period[curChart], i);
			         nb[curChart]=i;
			        }
                }
		        //----   
		        if(NormalizeDouble(minPoint*_Point[curChart],_Digits[curChart])<=
		           NormalizeDouble(MathAbs(iClose(_Symbol[curChart], _Period[curChart], i)-
		           iOpen(_Symbol[curChart], _Period[curChart], nb[curChart])),_Digits[curChart]))
                {
			        //----   
			        _open = iOpen(_Symbol[curChart], _Period[curChart], nb[curChart]);
			        _high = iHigh(_Symbol[curChart], _Period[curChart], iHighest(_Symbol[curChart], _Period[curChart],MODE_HIGH,nb[curChart]-i+1,i));
			        _low = iLow(_Symbol[curChart], _Period[curChart], iLowest(_Symbol[curChart], _Period[curChart],MODE_LOW,nb[curChart]-i+1,i));
			        _close = iClose(_Symbol[curChart], _Period[curChart], i);
			        _volume = vol;
			        _time = iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
			        _time *= sec;		        
			        //----     
			        HistoryFileWrite();
			        vol=0.0;
			        NewBar=true;
			       }
			      
			    i--; 
			    if(NewBar) {nb[curChart]=i;NewBar=false;}
			    
 		      }
		     last_fpos[curChart] = FileTell(HistoryHandle[curChart]);
		     Time_nb[curChart]=iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
		     Time_nb[curChart]*=sec;
	      //---- 
	      Print("<---   ,   ", _Symbol[curChart],",M",tmf, " --->");
	    }
	  //+------------------------------------------------------------------+
	  //|   
	  //+------------------------------------------------------------------+
	  while(!IsStopped())
	    {
		     RefreshRates();
		     for(curChart = 0; curChart < Charts; curChart ++)
		       {
			     //----  ""   
			     //---- (    ,  )
			     FileSeek(HistoryHandle[curChart], last_fpos[curChart], SEEK_SET);
			     //
			     //----    -  , 
			     if(TimeDayOfWeek(iTime(_Symbol[curChart],_Period[curChart],1))!=1 &&
                 TimeDayOfWeek(iTime(_Symbol[curChart],_Period[curChart],0))==1)
			      {
			       //----   
			       nb[curChart]=iBarShift(_Symbol[curChart],_Period[curChart],Time_nb[curChart]);
			       _open = iOpen(_Symbol[curChart], _Period[curChart], nb[curChart]);
			       _high = iHigh(_Symbol[curChart], _Period[curChart], iHighest(_Symbol[curChart], _Period[curChart],MODE_HIGH,nb[curChart],1));
			       _low = iLow(_Symbol[curChart], _Period[curChart], iLowest(_Symbol[curChart], _Period[curChart],MODE_LOW,nb[curChart],1));
			       _close = iClose(_Symbol[curChart], _Period[curChart], 1);
			       vol=0.0;
			       for(j=1; j<=nb[curChart]; j++) vol+=iVolume(_Symbol[curChart], _Period[curChart], j);
			       _volume = vol;
			       _time = iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
			       _time *=sec;
				    //----   
				    HistoryFileWrite();
				    //----    ,   0- 
				    last_fpos[curChart] = FileTell( HistoryHandle[curChart] );
				    Time_nb[curChart]=iTime(_Symbol[curChart], _Period[curChart], 0)/sec;
				    Time_nb[curChart]*=sec;
			      }
			      
			     nb[curChart]=iBarShift(_Symbol[curChart],_Period[curChart],Time_nb[curChart]);
			     //----    , 
			     if((iTime(_Symbol[curChart], _Period[curChart], nb[curChart])<=
			         iTime(_Symbol[curChart], _Period[curChart], 1))
			        &&
			        NormalizeDouble(minPoint*_Point[curChart],_Digits[curChart])<=
		           NormalizeDouble(MathAbs(iClose(_Symbol[curChart], _Period[curChart], 1)-
		           iOpen(_Symbol[curChart], _Period[curChart], nb[curChart])),_Digits[curChart]))
			      {
			       //----   
			       _open = iOpen(_Symbol[curChart], _Period[curChart], nb[curChart]);
			       _high = iHigh(_Symbol[curChart], _Period[curChart], iHighest(_Symbol[curChart], _Period[curChart],MODE_HIGH,nb[curChart],1));
			       _low = iLow(_Symbol[curChart], _Period[curChart], iLowest(_Symbol[curChart], _Period[curChart],MODE_LOW,nb[curChart],1));
			       _close = iClose(_Symbol[curChart], _Period[curChart], 1);
			       vol=0.0;
			       for(j=1; j<=nb[curChart]; j++) vol+=iVolume(_Symbol[curChart], _Period[curChart], j);
			       _volume = vol;
			       _time = iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
			       _time *=sec;
				    //----   
				    HistoryFileWrite();
				    //----    ,   0- 
				    last_fpos[curChart] = FileTell( HistoryHandle[curChart] );
				    Time_nb[curChart]=iTime(_Symbol[curChart], _Period[curChart], 0)/sec;
				    Time_nb[curChart]*=sec;
			      }
			      
			     nb[curChart]=iBarShift(_Symbol[curChart],_Period[curChart],Time_nb[curChart]);
			     _open = iOpen(_Symbol[curChart], _Period[curChart], nb[curChart]);
			     _high = iHigh(_Symbol[curChart], _Period[curChart],  iHighest(_Symbol[curChart], _Period[curChart],MODE_HIGH,nb[curChart]+1,0));
			     _low = iLow(_Symbol[curChart], _Period[curChart], iLowest(_Symbol[curChart], _Period[curChart],MODE_LOW,nb[curChart]+1,0));
			     _close = iClose(_Symbol[curChart], _Period[curChart], 0);
			     vol=0.0;
			     for(j=0; j<=nb[curChart]; j++) vol+=iVolume(_Symbol[curChart], _Period[curChart], j);
			     _volume = vol;
			     _time = iTime(_Symbol[curChart], _Period[curChart], nb[curChart])/sec;
              _time *=sec;
		        //----   
		        HistoryFileWrite();
			     //----  ,    ""  
			      if(hwnd[curChart] == 0)
			       {
			        
				     hwnd[curChart] = WindowHandle(_Symbol[curChart], tmf);
				     if(hwnd[curChart] != 0) 
				       Print("<---  ", _Symbol[curChart],",M",tmf," ! --->");
			       }
			      //----
			      if(hwnd[curChart] != 0) PostMessageA(hwnd[curChart], WM_COMMAND, 33324, 0);
		       }
		    Sleep(RefreshLuft);
	    }
	return(0);
 }
//+------------------------------------------------------------------+
void deinit()
{
 for(curChart=0; curChart<Charts; curChart++)
	if(HistoryHandle[curChart] >= 1) FileClose(HistoryHandle[curChart]);
}

void HistoryFileWrite()
{
 FileWriteInteger(HistoryHandle[curChart], _time, LONG_VALUE);
 FileWriteDouble(HistoryHandle[curChart], _open,  DOUBLE_VALUE);
 FileWriteDouble(HistoryHandle[curChart], _low,	  DOUBLE_VALUE);
 FileWriteDouble(HistoryHandle[curChart], _high,  DOUBLE_VALUE);
 FileWriteDouble(HistoryHandle[curChart], _close, DOUBLE_VALUE);
 FileWriteDouble(HistoryHandle[curChart], _volume,DOUBLE_VALUE);
 FileFlush(HistoryHandle[curChart]);
}

